<?php
ini_set("display_errors","on");
ini_set("register_globals","off");
error_reporting(E_ERROR|E_WARNING);
session_start();
define('DIR_PPAL',"/ruta_completa_al_CMS/");
define('DIR_CONFIG',DIR_PPAL.'config/');
define('DIR_FUNCIONES',DIR_PPAL.'funciones/');
define('DIR_CLASES',DIR_PPAL.'clases/');
define('DIR_IDIOMAS',DIR_PPAL.'idiomas/');
define('DIR_FUENTES',DIR_PPAL.'fuentes/');
require_once(DIR_CONFIG."config.php"); //configuracion de la web ,bd,etc
require_once(DIR_FUNCIONES.'general.php'); //FUNCIONES
require_once(DIR_CLASES.'clase_bd.php'); //BASE DE DATOS
require_once(DIR_CLASES.'clase_sesions.php'); //sesiones seguras
/**
 * Esta clase es la base de la clase base
 *
 */
class clase_base {
	/**
	 * Clase BD
	 *
	 * @var clase_bd
	 */
	var $bd;     //Base de datos de la web
	/**
	 * Operacion a realizar
	 *
	 * @var int
	 */
	var $op; //OPERACION

	/**
	 * Lenguage utilizado en toda la web
	 *
	 * @var str
	 *
	*/
	var $idioma;
	/**
	 * SesionS
	 *
	 * @var SesionSegura
	 */
	var $sesion;
	/**
	 * Clase Constructor de la clase base para usarla para todo
	 *
	 * @return clase_base
	 */
	function clase_base(){ //CONSTRUCTOR		
		$this->bd = new clase_bd(BD_HOST, BD_USER, BD_PASS, BD_NOMBRE,false);  //Crea una instancia de la clase de base de datos
		if (!$this->bd->conectado)
			die("Clase BASE: NO HAY BASE DE DATOS!");
		$this->op = parsearEntero("op",0);
		$this->comprobarLenguaje('len',DIR_IDIOMAS,'es');
		//Cargar idioma por defecto:
		require_once(DIR_IDIOMAS.$this->idioma.'/general.php');
		$this->sesion = new SesionSegura();
		//Destructor de la clase:
		register_shutdown_function(array( &$this, "destructor" ));
	}
	/**
	 * Destructor de la clase clase_base
	 *
	 */
	function destructor(){
		unset(
		 $this->bd, $this->op
		);
	}
	/**
	 * Comprueba el lenguaje al que se cambia,si no existe para la compilacion PHP
	 *
	 * @param str $variable
	 * @param str $dir_lenguajes
	 * @param str $idi_defecto
	 * @return bool si el idioma al que se cambia esta bien definido...
	 */
	function comprobarLenguaje($variable='len',$dir_lenguajes=DIR_IDIOMAS,$idi_defecto=IDIOMA_DEFECTO){
		//Comprobar el lenguaje:
		$len = (isset($_GET[$variable]) && !empty($_GET[$variable])?sanar($_GET[$variable]):(
			   (isset($_POST[$variable]) && !empty($_POST[$variable])?sanar($_POST[$variable]):
			   (isset($_COOKIE[$variable]) && !empty($_COOKIE[$variable])?sanar($_COOKIE[$variable]):detectar_idioma_navegador(IDIOMA_DEFECTO)))));
		$len = strtolower($len);
		if (is_dir($dir_lenguajes.$len)){
		 $this->idioma = $len;		 
		 define('DIR_IDIOMA',DIR_IDIOMAS.$len.'/');
		 include_once(DIR_IDIOMA.'fecha.php');
		 define('DIR_PLANTILLAS',DIR_IDIOMA.'plantillas/');
		 $salida = true;
		} else  {
		 $this->idioma = $idi_defecto;
		 $salida = false;
		 header("Location: index.php?len=es");
		 die('El lenguaje no existe || Language does not exists');
		}
		//Establecer cookie de lenguaje
		setcookie($variable,$this->idioma,time()+4600); //+ de 1hora cada vez
		return $salida;
	}
} //CLASE BASE GENERICA - FIN
?>